import datetime
import logging
import os

from charmworld.utils import get_ini

settings = get_ini()

CHARM_DIR = os.path.abspath(
    os.path.expanduser("%s/var/charms" % os.environ['HOME']))

CHARM_INDEX_DIR = os.path.join(
    CHARM_DIR, 'index')

LP_OUT_QUEUE = 'bzr-fetch'

BZR_IN_QUEUE = 'bzr-fetch'
BZR_OUT_QUEUE = 'charm-store'

STORE_IN_QUEUE = 'charm-store'
STORE_OUT_QUEUE = 'charm-proof'

PROOF_IN_QUEUE = 'charm-proof'
PROOF_OUT_QUEUE = 'charm-test'

JENKINS_IN_QUEUE = 'charm-test'
JENKINS_OUT_QUEUE = 'charm-log'

CHANGELOG_IN_QUEUE = 'charm-log'
CHANGELOG_OUT_QUEUE = 'charm-scan'

MONGO_HOST = settings.get('mongo.host')
MONGO_PORT = int(settings.get('mongo.port'))

CHARM_PROOF_PATH = "/usr/share/charm-tools/scripts"

STORE_URL = "https://store.juju.ubuntu.com"

CHARM_IMPORT_FILTER = '~charmers/charms/precise'
CHARM_IMPORT_LIMIT = 110


try:
    from custom_config import *
except ImportError:
    pass

log = logging.getLogger('charm.pipeline')


class RoutePipe(object):

    def __init__(self, name, redis, db):
        self.name = name
        self.redis = redis
        self.db = db
        self.log = logging.getLogger("charm.%s" % self.name)

    def start(self):
        self.log.debug('start')
        self.start()

    def error(self, pipe_data, e):
        self.log.exception("error on %s: %s", str(pipe_data), str(e))
        pipe_data['route-pipe'] = self.name
        pipe_data['error-time'] = datetime.datetime.now()
        self.log.error(pipe_data)
        self.db['ingest_errors'].insert(pipe_data)

    def _run(self):
        self.run()
