# Taken and Modified from trac / GPL
from ConfigParser import ConfigParser
import datetime
from dateutil.parser import parse
from os import environ
from os import path


_units = (
    (3600 * 24 * 365, '%d year'),
    (3600 * 24 * 30, '%d month'),
    (3600 * 24 * 7, '%d week'),
    (3600 * 24, '%d day'),
    (3600, '%d hour'),
    (60, '%d minute')
)


def pretty_timedelta(time1, time2=None):
    """Calculate time delta between two `datetime` objects.
    (the result is somewhat imprecise, only use for prettyprinting).
    """
    if isinstance(time1, (str, unicode)):
        time1 = parse(time1)
    if time2 is None:
        time2 = datetime.datetime.now()

    if time1 > time2:
        raise ValueError('The start date is before the end date.')

    diff = time2 - time1
    age_s = int(diff.days * 86400 + diff.seconds)

#    if age_s <= 60 * 1.9:
#        return ngettext('%(num)i second', '%(num)i seconds', age_s)
    for u, template in _units:
        r = float(age_s) / float(u)
        if r >= 1.9:
            r = int(round(r))
            v = template % r
            if r > 1:
                v += "s"
            return v
    return ''


def get_ini():
    """Fetch the ini file in use and provide a dict of values back.

    This is to mimic the access provided to the Pyramid app to outside code.
    It provides a dict from the ConfigParser instance in order to mimic access
    of request.registry.settings. It only provides the main app section of
    config data.

    The default ini file is the 'charmworld.ini', however it can be overridden
    by providing a INI=test.ini ENV variable.

    """
    ini_file = environ.get('INI', 'charmworld.ini')

    ini = ConfigParser()
    ini_path = path.join(path.dirname(path.dirname(__file__)),
                         ini_file)
    ini.readfp(open(ini_path))
    here = path.abspath(path.join(path.dirname(__file__), '../../'))
    ini.set('app:main', 'here', here)
    return dict(ini.items("app:main"))
