import json
from pyramid.view import view_config
from webob import Response

from charmworld import cached_view_config
from charmworld import graph
from charmworld.views.helpers import interfaces


@cached_view_config(
    route_name="json-interface-graph",
    #renderer="json",
)
def json_interface_graph(request):
    return Response(
        json.dumps(
            graph.graph_by_charms(
                request.db.charms.find(),
                interfaces(request.db)),
            indent=2),
        content_type=u"application/json")


@view_config(
    route_name="charm-graph",
    renderer="charmworld:templates/world-graph.pt",
)
def charm_graph(request):
    return {}
